HDU1045 Fire Net(DFS)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1045

Fire Net

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 8185    Accepted Submission(s): 4691

Problem Description

Suppose that we have a square city with straight streets. A map of a city is a square board with n rows and n columns, each representing a street or a piece of wall.
A blockhouse is a small castle that has four openings through which to shoot. The four openings are facing North, East, South, and West, respectively. There will be one machine gun shooting through each opening.
Here we assume that a bullet is so powerful that it can run across any distance and destroy a blockhouse on its way. On the other hand, a wall is so strongly built that can stop the bullets.
The goal is to place as many blockhouses in a city as possible so that no two can destroy each other. A configuration of blockhouses is legal provided that no two blockhouses are on the same horizontal row or vertical column in a map unless there is at least one wall separating them. In this problem we will consider small square cities (at most 4x4) that contain walls through which bullets cannot run through.
The following image shows five pictures of the same board. The first picture is the empty board, the second and third pictures show legal configurations, and the fourth and fifth pictures show illegal configurations. For this board, the maximum number of blockhouses in a legal configuration is 5; the second picture shows one way to do it, but there are several other ways.

Your task is to write a program that, given a description of a map, calculates the maximum number of blockhouses that can be placed in the city in a legal configuration.

Input

The input file contains one or more map descriptions, followed by a line containing the number 0 that signals the end of the file. Each map description begins with a line containing a positive integer n that is the size of the city; n will be at most 4. The next n lines each describe one row of the map, with a ‘.‘ indicating an open space and an uppercase ‘X‘ indicating a wall. There are no spaces in the input file.

Output

For each test case, output one line containing the maximum number of blockhouses that can be placed in the city in a legal configuration.

Sample Input

4

.X..

....

XX..

....

2

XX

.X

3

.X.

X.X

.X.

3

...

.XX

.XX

4

....

....

....

....

0

Sample Output

5

1

5

2

4

题意: 有图n*n一张, 图里有地方有“墙”, 然后往里面放子弹, 子弹不能和子弹同列或同行(除非被墙隔开啦!), 问:最多能放多少子弹?

/*
本题思路: 暴力DFS, 每个点都先假设放上子弹,
然后判断是否成立再DFS。不过在分别判断行和列是否合法
时, 是从小到大DFS的, 所以只判断前面的即可!
*/
#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;

char pic[10][10];
int ans, n;
int Judge(int row, int col)
{
    for(int i=col-1; i>=0; i--)//判断所在列
    {
        if(pic[row][i]==‘a‘) return false;
        if(pic[row][i]==‘X‘) break;
    }
    for(int i=row-1; i>=0; i--)//判断所在行
    {
        if(pic[i][col]==‘a‘) return false;
        if(pic[i][col]==‘X‘) break;
    }
    return true;
}
void dfs(int cur, int tot)
{
    if(cur==n*n)
    {
        ans = max(ans, tot);
        return;
    }
    else
    {
        int row = cur/n;//这里是一个很有意思的小技巧
        int col = cur%n;
        if(pic[row][col]==‘.‘&&Judge(row, col))
        {
            pic[row][col]=‘a‘;
            dfs(cur+1, tot+1);
            pic[row][col] = ‘.‘;
        }
        dfs(cur+1, tot);
    }
}

int main()
{
    while(scanf("%d", &n), n)
    {
        memset(pic, 0, sizeof(pic));
        for(int i=0; i<n; i++)
        scanf("%s", pic[i]);
        ans = 0;
        dfs(0, 0);
        printf("%d\n", ans);
    }
    return 0;
}

然而上述代码有一个缺陷,前面的行和列坑能合理。但是可能放置子弹后(后面也有子弹且无墙),导致不合理。 然而这道题的数据奇弱,因此能过。

下述代码虽然比上面的跑的稍慢,但仍是0ms飘过。(这道题的数据规模真是亲民)

#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;

char pic[10][10];
int ans, n;
int Judge(int row, int col)
{
    for(int i=n-1; i>=0; i--)//判断所在列
    {
        if(pic[row][i]==‘a‘) return false;
        if(pic[row][i]==‘X‘) break;
    }
    for(int i=n-1; i>=0; i--)//判断所在行
    {
        if(pic[i][col]==‘a‘) return false;
        if(pic[i][col]==‘X‘) break;
    }
    return true;
}
void dfs(int cur, int tot)
{
    if(cur==n*n)
    {
        ans = max(ans, tot);
        return;
    }
    else
    {
        int row = cur/n;//这里是一个很有意思的小技巧
        int col = cur%n;
        if(pic[row][col]==‘.‘&&Judge(row, col))
        {
            pic[row][col]=‘a‘;
            dfs(cur+1, tot+1);
            pic[row][col] = ‘.‘;
        }
        dfs(cur+1, tot);
    }
}

int main()
{
    while(scanf("%d", &n), n)
    {
        memset(pic, 0, sizeof(pic));
        for(int i=0; i<n; i++)
        scanf("%s", pic[i]);
        ans = 0;
        dfs(0, 0);
        printf("%d\n", ans);
    }
    return 0;
}
时间: 2024-10-29 10:48:46

HDU1045 Fire Net(DFS)的相关文章

hdu1045 Fire Net(DFS枚举)

http://acm.hdu.edu.cn/showproblem.php?pid=1045 这是在贪心分类里面的题目,然而我第一眼看到时候还是想到了dfs,毕竟只有4*4……数据小,枚举也能AC 用DFS枚举所有状态…… #include <iostream> #include <cstdio> #include <cstdlib> #include <cstring> #include <algorithm> #include <cma

ZOJ 1002 Fire Net(dfs)

嗯... 题目链接:https://zoj.pintia.cn/problem-sets/91827364500/problems/91827364501 这道题是想出来则是一道很简单的dfs: 将一个4*4的地图给每一个点排序,如下图: 0  1  2  3 4  5  6  7 8  9  10  11 12 13 14 15 设一个点为第k个点,那么它的坐标为(k/n,k%n),根据这个进行dfs,当k == n * n是退出dfs.如果k < n *n,就继续dfs,判断是否能放下,即要

Fire Net(dfs)

Fire Net Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 7944    Accepted Submission(s): 4534 Problem Description Suppose that we have a square city with straight streets. A map of a city is a s

TOJ 1162 Fire Net(dfs)

Suppose that we have a square city with straight streets. A map of a city is a square board with n rows and n columns, each representing a street or a piece of wall. A blockhouse is a small castle that has four openings through which to shoot. The fo

HDU 1045 - Fire Net (最大独立集)

题意:给你一个正方形棋盘.每个棋子可以直线攻击,除非隔着石头.现在要求所有棋子都不互相攻击,问最多可以放多少个棋子. 这个题可以用搜索来做.每个棋子考虑放与不放两种情况,然后再判断是否能互相攻击来剪枝.最后取可以放置的最大值. 这里我转化成求最大独立集来做. 首先将每个空地编号,对于每个空地,与该位置可以攻击到的空地连边.找最多的空地使得不互相攻击,即求该图的最大独立集.与搜索做法基本一致,但是说法略有不同. 1 #include<iostream> 2 #include<cstring

POJ 3087 Shuffle&#39;m Up (DFS)

题目链接:Shuffle'm Up 题意:有a和b两个长度为n的字符序列,现定义操作: 将a.b的字符交叉合并到一个序列c,再将c最上面的n个归为a,最下面n个归为b 给出a,b和目标序列c,问最少多少次操作a.b转化为c 解析:将a.b放入哈希表,然后模拟操作过程直接dfs即可. AC代码: #include <cstdio> #include <iostream> #include <cstring> #include <map> using names

LeetCode Subsets (DFS)

题意: 给一个集合,有n个互不相同的元素,求出所有的子集(包括空集,但是不能重复). 思路: DFS方法:由于集合中的元素是不可能出现相同的,所以不用解决相同的元素而导致重复统计. 1 class Solution { 2 public: 3 vector<vector<int>> subsets(vector<int>& nums) { 4 sort(nums.begin(),nums.end()); 5 DFS(0,nums,tmp); 6 return a

POJ 1699 Best Sequence(DFS)

題目鏈接 題意 : 將幾個片段如圖所示方法縮成一個序列,求出最短這個序列. 思路 : 其實我也不知道怎麼做.....看網上都用了DP.....但是我不會.....這個DP不錯,還有用KMP+状压DP做的 1 //1699 2 #include <iostream> 3 #include <stdio.h> 4 #include <string.h> 5 #include <string> 6 7 using namespace std; 8 9 string

LeetCode Subsets II (DFS)

题意: 给一个集合,有n个可能相同的元素,求出所有的子集(包括空集,但是不能重复). 思路: 看这个就差不多了.LEETCODE SUBSETS (DFS) 1 class Solution { 2 public: 3 vector<vector<int>> subsets(vector<int>& nums) { 4 sort(nums.begin(),nums.end()); 5 DFS(0,nums,tmp); 6 ans.push_back(vector